#!/bin/bash

# génération d'un fichier de 200 ko
./Generateur.sh fic200k.bin 50000
rm data/copy/fic200k.bin 2> /dev/null
mv fic200k.bin data/source

# Lancement de deux serveurs
./scriptsTest/ServeurAide.sh 4545 &
pid1=$!

# Le second serveur est défaillant: il ne transmet pas l'intégralité du bloc demandé.
./scriptsTest/ServeurDefaillant.sh  4546 &
pid2=$!

# on attend le démarage des serveurs
sleep 1


# TEST DU CLIENT 
# Import du fichier
./Client.sh fic200k.bin

#vérification

if diff data/copy/fic200k.bin data/source/fic200k.bin ; then
    echo test OK
else
    echo test KO
fi

# on tue les 2 serveurs
kill $pid1 $pid2

exit 0


