#!/bin/bash

# génération d'un fichier de 200 ko
./Generateur.sh fic200k.bin 50000
# génération d'un fichier de 100 ko
./Generateur.sh fic100k.bin 25000
rm data/copy/fic200k.bin 2> /dev/null
rm data/copy/fic100k.bin 2> /dev/null
mv fic200k.bin data/source
mv fic100k.bin data/source

# TEST DU CLIENT 
# Lancement d'un serveurs
./Serveur.sh 4545 &
pid1=$!

# on attend le démarage des serveurs
sleep 1



# Import du fichier
./scriptsTest/ClientAide.sh fic200k.bin &
client1=$!

./scriptsTest/ClientAide.sh fic100k.bin &
client2=$!

wait $client1 $client2

#vérification

if diff data/copy/fic200k.bin data/source/fic200k.bin && diff data/copy/fic100k.bin data/source/fic100k.bin; then
    echo test OK
else
    echo test KO
fi

# on tue le serveur
kill $pid1

exit 0


