package tsp.csc4509.tpnote;

import static tsp.csc4509.common.Log.GEN;
import java.io.IOException;
import java.net.InetSocketAddress;
import java.net.StandardSocketOptions;
import java.nio.channels.ServerSocketChannel;
import java.nio.channels.SocketChannel;
import java.util.concurrent.BlockingQueue;
import java.util.concurrent.LinkedBlockingQueue;

public class Server {
//public class Server extends tsp.csc4509.tpnote.aide.ServerAide {

	/**
	 * Nombre de threads lancés dans le pool.
	 */
	private static final int NBTHREADS = 4;

	/**
	 * le canal gérant les accepts du serveur.
	 */
	private ServerSocketChannel listenChannel;

	/**
	 * Constructeur de Server qui ouvre le canal du serveur et le lie au port passé
	 * en paramètre.
	 * 
	 * @param port port que doit occuper le serveur.
	 * @throws IOException toutes les exceptions d'entrées/sorties qui peuvent se
	 *                     produire.
	 */
	public Server(final int port) throws IOException {
		// TODO Question 4.
	}

	/**
	 * Accepte la connexion d'un client sur le canal listenChannel.
	 * 
	 * @return le canal relié au client qui vient de se connecter.
	 * @throws IOException toutes les exceptions d'entrées/sorties qui peuvent se
	 *                     produire.
	 */
	public SocketChannel accept() throws IOException {
		// TODO Question 5.
		return null;
	}

	/**
	 * Implémente le service: (1) crée la file d'attente pour envoyer les demandes
	 * aux threads; (2) lance un pool de NBTHREADS threads; (3) accepte tous les
	 * clients qui se connectent et place leur canaux dans la file d'attente.
	 * 
	 * @throws IOException          toutes les exceptions d'entrées/sorties qui
	 *                              peuvent se produire.
	 * @throws InterruptedException exception due la gestion de la BlockingQueue.
	 */
	public void service() throws IOException, InterruptedException {
		// le service n'est pas robuste: il ne récupère pas des exceptions
		// TODO Question 6.
	}

	// *****************
	// Getters sur les attributs ajoutés à la classe pour l'écriture des tests.
	// Ils ne doivent pas être utilisés dans votre code. Seule la classe Serveur
	// doit manipuler ces attributs.
	/**
	 * Getter sur listenChannel.
	 * 
	 * @return l'attribut listenChannel.
	 */
	public ServerSocketChannel getListenChannel() {
		return listenChannel;
	}
}
